clear;



function x = newton(F,DF,x0,Tol,MaxIter)
    x = x0;
    err = Tol+1;
    iter = 0;
    while (err>Tol)&(iter<MaxIter)
        iter = iter+1;
        dx = DF(x)\F(x);
        xnew = x - dx;
        err = norm(x-xnew);
        x = xnew;
    end
endfunction



function y=F1(x)
    y = exp(x)-exp(1);
endfunction

function y=DF1(x)
    y = exp(x);
endfunction


disp("---- methode de Newton pour la resolution de exp(x)=e ----")

x = newton(F1,DF1,0,1e-5,20)
disp("solution : x =")
disp(x)




function y=F2(x)
    y = [x(1)^2+x(2)^2-2;x(1)^2-x(2)^2-1];
endfunction

function y=DF2(x)
    y = [2*x(1),2*x(2);2*x(1),-2*x(2)];
endfunction


disp("---- methode de Newton pour la resolution du systeme non-lineaire  ----")

x = newton(F2,DF2,[1;1],1e-5,20)
disp("solution : x =")
disp(x)
disp("|| F(x) || =")
disp(norm(F2(x)))
